<?php

namespace App\Http\Requests;


use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use App\Day;

class DayRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('days'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
       
        if($this->day){
                 $day = Day::where('date',request('date'))->where('id','!=',$this->day->id)->first();
            if($day){
                return ['date_taken'=>'required'];
            }
           $rules = [
    'date'=> 'required',
    'file'=> 'sometimes|mimes:pdf',
    ];
       }
       else{
     
     $day = Day::where('date',request('date'))->first();
            if($day){
                return ['date_taken'=>'required'];
            }
$rules = [
    'date'=> 'required',
    'file'=> 'required|mimes:pdf',
    ];
           
       }
         
       

        return $rules;
    }
public function messages()
    {
        return [
            'date_taken.required'=>__('days.date_taken'),
            ];
    }
    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'date'=>  __('days.date'),
            'file'=>  __('days.file'),
            'end'=>  __('days.end'),
        ];
         foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local => $service->{'title_'.$lang->local} ?? __('days.title'),
                'slug_'.$lang->local => $service->{'slug_'.$lang->local} ?? __('days.slug'),
                'keywords_'.$lang->local => $service->{'keywords_'.$lang->local} ?? __('days.keywords'),
                'description_'.$lang->local => $service->{'description_'.$lang->local} ?? __('days.description'),
                'description_'.$lang->local => $service->{'description_'.$lang->local} ?? __('days.description'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
}
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
